"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var AbstractRPC = /** @class */ (function () {
    function AbstractRPC(channel) {
        var _this = this;
        this.channel = channel;
        this.errorHandler = null;
        this.onError = function (handler) {
            _this.errorHandler = handler;
            return _this;
        };
        this.fireError = function (error) {
            if (_this.errorHandler) {
                _this.errorHandler(error);
            }
        };
        this.channel.addEventListener('error', this.fireError);
    }
    return AbstractRPC;
}());
exports.AbstractRPC = AbstractRPC;
