import { AbstractRPC } from './abstract';
import { RPCChannel } from './types';
import { RPCDeclaration } from './utils/type';
declare const InternalCall: unique symbol;
declare const InternalPost: unique symbol;
export declare class RPCWithTransfer<RPC extends RPCDeclaration<RPC>> {
    private client;
    private transfers?;
    constructor(client: RPCClient<RPC>, transfers?: Transferable[] | undefined);
    call: RPCClient<RPC>['call'];
    post: RPCClient<RPC>['post'];
}
export declare class RPCClient<RPC extends RPCDeclaration<RPC>> extends AbstractRPC {
    private idSerial;
    private resolvers;
    constructor(worker: RPCChannel);
    withTransfer(...transfers: Transferable[]): RPCWithTransfer<RPC>;
    call: <M extends { [K in keyof RPC]: import("./utils/type").PostMethodCondition<RPC[K], never, K>; }[keyof RPC]>(method: M, ...args: Parameters<RPC[M]>) => Promise<ReturnType<RPC[M]>>;
    [InternalCall]: <M extends { [K in keyof RPC]: import("./utils/type").PostMethodCondition<RPC[K], never, K>; }[keyof RPC]>(method: M, transfer: Transferable[] | undefined, ...args: Parameters<RPC[M]>) => Promise<ReturnType<RPC[M]>>;
    post: <M extends Exclude<keyof RPC, { [K in keyof RPC]: import("./utils/type").PostMethodCondition<RPC[K], never, K>; }[keyof RPC]>>(method: M, ...args: Parameters<RPC[M]>) => void;
    [InternalPost]: <M extends Exclude<keyof RPC, { [K in keyof RPC]: import("./utils/type").PostMethodCondition<RPC[K], never, K>; }[keyof RPC]>>(method: M, transfer: Transferable[] | undefined, ...args: Parameters<RPC[M]>) => void;
    private onMessage;
}
export {};
