import { AbstractRPC } from './abstract';
import { RPCChannel } from './types';
import { AnyFunction, CallMethodNames, PostMethodCondition, PostMethodNames, PromiseOrValue, RPCDeclaration } from './utils/type';
declare type RPCHandlerRType<F extends AnyFunction> = ReturnType<F> extends void ? (void | {
    result?: never;
    transfer: Transferable[];
}) : {
    result: ReturnType<F>;
    transfer?: Transferable[];
};
declare type RPCHandler<F extends AnyFunction> = (...args: Parameters<F>) => PromiseOrValue<PostMethodCondition<F, void, RPCHandlerRType<F>>>;
interface PostRPCHandlerOptions {
    noReturn: true;
}
declare type CallRPCHandlerOptions = never;
declare type RPCHandlerOptions<F extends AnyFunction> = PostMethodCondition<F, PostRPCHandlerOptions, CallRPCHandlerOptions>;
interface RPCServerOnMethod<RPC extends RPCDeclaration<RPC>> {
    <M extends CallMethodNames<RPC>>(method: M, handler: RPCHandler<RPC[M]>, options?: RPCHandlerOptions<RPC[M]>): RPCServer<RPC>;
    <M extends PostMethodNames<RPC>>(method: M, handler: RPCHandler<RPC[M]>, options: RPCHandlerOptions<RPC[M]>): RPCServer<RPC>;
}
export declare class RPCServer<RPC extends RPCDeclaration<RPC>> extends AbstractRPC {
    private readonly handlers;
    constructor(channel: RPCChannel);
    on: RPCServerOnMethod<RPC>;
    private onMessage;
    private executeHandler;
}
export {};
